unit haupt;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ComCtrls, Spin, Menus, ExtCtrls, math,
  lcltype, sqlitetable3,
  //eigene
  audiofile, sammlung, threads, playlist, playlisten;

type

  { Tfrmhaupt }

  Tfrmhaupt = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { private declarations }
    procedure OnMPlay(Sender:TObject);
    procedure OnMPause(Sender:TObject);
    procedure OnMStop(Sender:TObject);
    procedure OnMResume(Sender:TObject);
    procedure OnMChange(Sender:TObject);
  public
    { public declarations }
    procedure LadeAllgEinstellungen;
    procedure AddDirToBiblio;
    procedure BiblioAnzeige;
    procedure InfoTextAkt;
    procedure OnPlaylistAddItem(Sender:TObject; NewAudioFile:TAudioFile);
  end; 

var
  frmhaupt: Tfrmhaupt;

implementation

{ Tfrmhaupt }

procedure Tfrmhaupt.FormCreate(Sender: TObject);
var selected:string;
begin
 if not FileExists('music.db') then
  CreateTextFile('music.db');
 smbdb := TSQLiteDatabase.Create('music.db');
 if not FileExists('playlist.db')
  then CreateTextFile('playlist.db');
 pldb := TSQLiteDatabase.Create('playlist.db');
 if not FileExists('data.db')
  then CreateTextFile('data.db');
 smbpdb := TSQLiteDatabase.Create('data.db');
 {$IFDEF UNIX}
  SelectDirectory('Basisordner öffnen','',selected);
  OwnDirection := selected;
 {$ENDIF}
 {$IFDEF WIN32}
  OwnDirection := ExtractFileDrive(Application.ExeName);
 {$ENDIF}
 PCRegName := Computername;
 //BPlaylist Initialisieren
 BPlaylist := TPlaylist.Create;
 BPLaylist.InitBassEngine(Handle);
 BPlaylist.InitPlugins(ExtractFileDir(ParamStr(0)));
 BPlaylist.Volume    := (-1)*TrackBar2.Position/100;
 BPlaylist.OnPlay    := @OnMPlay;
 BPlaylist.OnResume  := @OnMResume;
 BPlaylist.OnPause   := @OnMPause;
 BPlaylist.OnStop    := @OnMStop;
 BPlaylist.OnChange  := @OnMChange;
 BPlaylist.OnAddItem := @OnPlaylistAddItem;
 BPlaylist.FadeIn    := 5000;
 BPlaylist.FadeOut   := 5000;
 BPlaylist.SetPan(0);
end;

procedure Tfrmhaupt.Button1Click(Sender: TObject);
begin
 case BPlaylist.BassStatus of
  0: begin
      BPlaylist.Play(-1,false);
      InfoTextAkt;
     end;
  1: begin
      BPlaylist.Stop;
     end;
 end;
end;

procedure Tfrmhaupt.Button2Click(Sender: TObject);
begin
 case BPlaylist.BassStatus of
  1: begin
      BPlaylist.Pause;
     end;
  3: begin
      BPlaylist.Resume;
     end;
 end;
end;

procedure Tfrmhaupt.Button3Click(Sender: TObject);
begin
 BPlaylist.PlayPrevious;
 InfoTextAkt;
end;

procedure Tfrmhaupt.Button4Click(Sender: TObject); //Next
begin
 BPlaylist.PlayNext(false);
 InfoTextAkt;
end;

procedure Tfrmhaupt.Button5Click(Sender: TObject); //Fade
begin
 BPlaylist.PlayNext(true);
 InfoTextAkt;
end;

procedure Tfrmhaupt.FormDestroy(Sender: TObject);
begin
 smbdb.Free;
 //music.db close in Protokoll schreiben
 pldb.Free;
 //playlist.db close in Protokoll schreiben
 smbpdb.Free;
end;

procedure Tfrmhaupt.MenuItem2Click(Sender: TObject);
begin
  close;
end;

procedure Tfrmhaupt.SpinEdit1Change(Sender: TObject);  //Fade In
begin
 BPlaylist.FadeIn := round(SpinEdit1.Value*1000);
end;

procedure Tfrmhaupt.SpinEdit2Change(Sender: TObject);  //Fade Out
begin
 BPlaylist.FadeOut := round(SpinEdit2.Value*1000);
end;

procedure Tfrmhaupt.SpinEdit3Change(Sender: TObject);  //Tempo
begin
 //Noch nicht integriert
end;

procedure Tfrmhaupt.SpinEdit4Change(Sender: TObject);  //Balance
begin
 BPlaylist.SetPan(SpinEdit4.Value/10);   //Defekt?? --> TESTEN
end;

procedure Tfrmhaupt.Timer1Timer(Sender: TObject);
var t:integer;
    Level,LLevel,RLevel:dword;
begin
 //Fortschrittsanzeige
 TrackBar1.Position := round(BPlaylist.Progress*100);
 //Fortschrittszeit
 t := round(BPlaylist.Time);
 label1.Caption := ' '+Format('%.2d:%.2d',[t div 60, t mod 60])+' ';
 //Laufschrift Liedinfos
 Label6.Caption := copy(MarqueeTitle,1,MarqueeCount);
 inc(MarqueeCount);
 if MarqueeCount>length(MarqueeTitle) then marqueeCount := 1;
 //Noch nicht integrierte Channellevelanzeige (Nicht Lautstärkeabhängig!!! -->Auslastung!!)
 Level := BPlaylist.GetChannelLevel;
 LLevel := trunc(LoWord(Level)/400);
 RLevel := trunc(HiWord(Level)/400);
 //Soud spielen
 if BPlaylist.BassStatus = 1 then
 begin
  if round(BPlaylist.Time) > BPlaylist.PlayingFile.Dauer-(BPlaylist.FadeOut/1000) then
  begin
   BPlaylist.PlayNext(true);
   InfoTextAkt;
  end;
 end;
 //Datumsanzeige
 StatusBar1.Panels.Items[1].Text := DateTimeToStr(now);
end;

procedure Tfrmhaupt.TrackBar1Change(Sender: TObject);
begin
 BPlaylist.Progress := TrackBar1.Position/100;
end;

procedure Tfrmhaupt.TrackBar2Change(Sender: TObject);
begin
 BPlaylist.Volume := TrackBar2.Position/100*(-1);
end;

procedure Tfrmhaupt.LadeAllgEinstellungen;
begin

end;

procedure Tfrmhaupt.OnMPlay(Sender: TObject);
begin
 Timer1.Enabled := true;
 Button1.Caption := 'Stop';
 TrackBar1.Position := 0;
 //frmplaylisten.ListView1.Refresh;
end;

procedure Tfrmhaupt.OnMPause(Sender: TObject);
begin
 Timer1.Enabled := false;
 Button2.Caption := 'Weiter';
end;

procedure Tfrmhaupt.OnMStop(Sender: TObject);
begin
 Timer1.Enabled := false;
 Button1.Caption := 'Play';
 TrackBar1.Position := 0;
end;

procedure Tfrmhaupt.OnMResume(Sender: TObject);
begin
 Timer1.Enabled := true;
 Button2.Caption := 'Pause';
end;

procedure Tfrmhaupt.OnMChange(Sender: TObject);
begin
 InfoTextAkt;
end;

procedure Tfrmhaupt.InfoTextAkt;
var s:string;
begin
 Showmessage('Titel laden');
 if (BPlaylist.BassStatus = 1) or (BPlaylist.BassStatus = 3) then
 begin
  with BPlaylist.PlayingFile do
  begin
   s := Titel+' - ';
   s := s+Interpret+' - ';
   s := s+IntToStr(Dauer);
  end;
  MarqueeTitle := s;
  MarqueeCount := 1;
 end;
 ShowMessage('Titel laden beendet');
end;

procedure Tfrmhaupt.AddDirToBiblio;
var AddDir:TAddDir;
begin
 if not adddirbol then
 begin
  anzeigeprogressbar[1] := Progressbar2;
  AddDir.Create(true).Resume;
  ShowMessage('Daten werden hinzugefügt.');
 end else
  ShowMessage('Es wird bereits ein Ordner hinzugefügt. Bitte Warten, bis dies geschehen ist.');
end;

procedure Tfrmhaupt.BiblioAnzeige;
var anzeige:TAnzeige;
begin
 if not anzeigebol then
 begin
  frmplaylisten.ListView2.Clear;
  try
   anzeigeprogressbar[0] := Progressbar1;
   anzeige.Create(true).Resume;
  except
   ShowMessage('Fehler bei Zugriff auf MusikDB. Neustart könnte das Problem beheben.');
  end;
  frmplaylisten.Label1.Caption := IntToStr(frmplaylisten.ListView2.Items.Count);
 end else
  ShowMessage('Die Aufbereitung der Biblioanzeige läuft bereits.');
end;

procedure Tfrmhaupt.OnPlaylistAddItem(Sender: TObject; NewAudioFile: TAudioFile);
var newItem:TListItem;
    i:integer;
begin
 newItem := frmplaylisten.ListView1.Items.Add;
 newItem.Caption := NewAudioFile.Titel;
 newItem.SubItems.Add(NewAudioFile.Interpret);
 newItem.SubItems.Add('');                 //Album
 i := NewAudioFile.Dauer;
 NewItem.SubItems.Add(Format('%d:%.2d',[i div 60, i mod 60]));
 newItem.SubItems.Add('');        //Genre
 newItem.SubItems.Add('');        //Kommentar
 newItem.SubItems.Add(NewAudioFile.Pfad);
 NewItem.Data := NewAudioFile;
end;

initialization
  {$I haupt.lrs}

end.

