unit sammlung;

{$mode objfpc}{$H+}

interface

uses {$IFDEF WINDOWS}Windows, {$ENDIF}
  {$IFDEF UNIX}unix, {$ENDIF}
  Classes, SysUtils, playlist, sqlitetable3;

type TDateiPfadInfos = record
      Drive, Name, Gesamt:string;
     end;

procedure CreateTextFile(FileName:string);
function ComputerName: String;
procedure FindAllFiles(const FileList: tstrings;RootFolder: string; Maske: array of string; Recurse: Boolean = True);

var smbdb, pldb, smbpdb: TSQLiteDatabase;
    OwnDirection, PCRegName:string;
    BPlaylist: TPlaylist;
    MarqueeTitle:string;
    MarqueeCount:integer;

implementation

procedure CreateTextFile(FileName:string);
var
  f:text;
begin
  assignfile(f, FileName);
  rewrite(f);
  closefile(f);
end;

{$IFDEF WINDOWS}
function Win32GetComputerName: string;
var
  Size: DWORD;
begin
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  SetLength(Result, Size);
  if GetComputerName(PChar(Result), Size) then
    SetLength(Result, Size)
  else
    Result := '';
end;
{$ENDIF}

function ComputerName: string;
begin
{$IFDEF WINDOWS}
 result := Win32GetComputerName;
{$ENDIF}
{$IFDEF UNIX}
 result := GetHostName;
{$ENDIF}
end;

procedure FindAllFiles(const FileList: tstrings;RootFolder: string; Maske: array of string; Recurse: Boolean = True);
var                                                                //Linuxtauglich???
  SR: TSearchRec;
  i : integer;
begin
  RootFolder := IncludeTrailingPathDelimiter(RootFolder);

  if Recurse then
    if FindFirst(RootFolder + '*.*', faAnyFile, SR) = 0 then
    try
      repeat
        if SR.Attr and faDirectory = faDirectory then
            // --> ein Verzeichnis wurde gefunden
            // der Verzeichnisname steht in SR.Name
            // der vollständige Verzeichnisname (inkl. darüberliegender Pfade) ist
            // RootFolder + SR.Name
          if (SR.Name <> '.') and (SR.Name <> '..') then
            FindAllFiles(FileList, RootFolder + SR.Name, Maske, Recurse);
      until FindNext(SR) <> 0;
    finally
      FindClose(SR);
    end;
  i := 0;
  repeat
    begin
      if FindFirst(RootFolder + '*' + Maske[i], faAnyFile, SR) = 0 then
      try
        repeat
          if SR.Attr and faDirectory <> faDirectory then
          begin
            // --> eine Datei wurde gefunden
            // der Dateiname steht in SR.Name
            // der vollständige Dateiname (inkl. Pfadangabe) ist
            // RootFolder + SR.Name
            FileList.Add(RootFolder + SR.Name);
          end;
        until FindNext(SR) <> 0;
      finally
        FindClose(SR);
      end;
      i := i + 1;
    end
  until
    i = high(maske) + 1;
end;


end.

