unit threads;

{$mode objfpc}{$H+}

interface

uses
  {$ifdef unix}
   cthreads,
  {$endif}
  Classes, SysUtils, ComCtrls, sqlitetable3, Dialogs,
  //Eigene
  playlisten, sammlung, audiofile;

type TAnzeige = class(TThread)
     private
      procedure BiblioAnzeige;
      procedure UpdateAnzeige;
     protected
      procedure Execute; override;
     public
      constructor Create(CreateSuspended:boolean);
     end;

     TAddDir = class(TThread)
     private
      procedure AddDirToBiblio;
     protected
      procedure Execute; override;
     public
      constructor Create(CreateSuspended:boolean);
     end;

var anzeigesltb:TSQLiteTable;
    anzeigenewItem: TListItem;
    anzeigeprogressbar:array[0..1] of TProgressBar;
    anzeigebol, anzeigeOwn:boolean;
    adddirbol:boolean;

implementation

constructor TAnzeige.Create(CreateSuspended:boolean);
begin
 FreeOnTerminate := true; //Autostart des Threads verhindern --> Start über Resume
 inherited Create(CreateSuspended);
end;

constructor TAddDir.Create(CreateSuspended:boolean);
begin
 FreeOnTerminate := true; //Autostart des Threads verhindern --> Start über Resume
 inherited Create(CreateSuspended);
end;

procedure TAnzeige.BiblioAnzeige;  //Routine Verbessern --> sonst nur ~35.000 Titel/Tabelle möglich
var i:integer;
begin
 anzeigeprogressbar[0].Min := 0;
 frmplaylisten.Label1.Caption := '0';
 if smbdb.TableExists('OwnDrive') then
 begin
  AnzeigeOwn := true;
  anzeigesltb := smbdb.GetTable('SELECT * FROM OwnDrive ORDER BY Interpret');
  if anzeigesltb.Count > 0 then
  begin
   anzeigeprogressbar[0].Max := anzeigesltb.Count-1;
   anzeigeprogressbar[0].Position := 0;
   for i := 0 to anzeigesltb.Count-1 do
   begin
    Synchronize(@UpdateAnzeige);
    anzeigeprogressbar[0].Position := anzeigeprogressbar[0].Position+1;
    anzeigesltb.Next;
   end;
  end;
 end;
 if smbdb.TableExists(pcregname) then
 begin
  anzeigeOwn := false;
  anzeigesltb := smbdb.GetTable('SELECT * FROM '+pcregname+' ORDER BY Interpret');
  if anzeigesltb.Count > 0 then
  begin
   anzeigeprogressbar[0].Max := anzeigesltb.Count-1;
   anzeigeprogressbar[0].Position := 0;
   for i := 0 to anzeigesltb.Count-1 do
   begin
    Synchronize(@UpdateAnzeige);
    anzeigeprogressbar[0].Position := anzeigeprogressbar[0].Position+1;
    anzeigesltb.Next;
   end;
  end;
 end;
 anzeigeprogressbar[0].Position := 0;
 anzeigenewItem.free;
 anzeigesltb.Free;
end;

procedure TAnzeige.UpdateAnzeige;
var i:integer;
begin
 anzeigenewitem := frmplaylisten.ListView2.Items.Add;
 anzeigenewitem.Caption := anzeigesltb.FieldAsString(anzeigesltb.FieldIndex['Titel']);
 anzeigenewItem.SubItems.Add(anzeigesltb.FieldAsString(anzeigesltb.FieldIndex['Interpret']));
 anzeigenewItem.SubItems.Add('');                 //Album
 i := StrToInt(anzeigesltb.FieldAsString(anzeigesltb.FieldIndex['Dauer']));
 anzeigeNewItem.SubItems.Add(Format('%d:%.2d',[i div 60, i mod 60]));
 anzeigenewItem.SubItems.Add('');        //Genre
 anzeigenewItem.SubItems.Add('');        //Kommentar
 if anzeigeOwn then               //auf Linuxtauglichkeit testen!!! --> Pfadangaben...
  anzeigenewItem.SubItems.Add(OwnDirection+'\'+anzeigesltb.FieldAsString(anzeigesltb.FieldIndex['Pfad']))
 else
  anzeigenewItem.SubItems.Add(anzeigesltb.FieldAsString(anzeigesltb.FieldIndex['Pfad']));
 frmplaylisten.Label1.Caption := IntToStr(StrToInt(frmplaylisten.Label1.Caption)+1);
end;

procedure TAnzeige.Execute;
begin
 anzeigebol := true;
 BiblioAnzeige();
 anzeigebol := false;
end;

procedure TAddDir.AddDirToBiblio;
var DirList:TStringList;
    RootDir, lw: string;
    i:integer;
    mask:array of string;
    bol:boolean;
    AudioFile:TAudioFile;
    SQL:string;
    AktDatei:TDateiPfadInfos;
begin
 anzeigeprogressbar[1].Min := 0;
 bol := false;
 DirList := TStringList.Create;
 SelectDirectory('Ordner auswählen',OwnDirection,RootDir,true);
 setLength(mask,1);
 mask[0] := '.mp3'; //Hier können weitere Endungen definiert werden.
 FindAllFiles(DirList, RootDir, mask, true);
 {$ifdef WIN32}
  lw := ExtractFileDrive(RootDir);
 {$endif}
 {$ifdef UNIX}
  if pos(OwnDirection, RootDir) = 0 then
   lw := RootDir
  else
   lw := OwnDirection;
 {$endif}

 //Starten der Transaction
 smbdb.BeginTransaction;

 if lw = OwnDirection then
 begin
  if not smbdb.TableExists('OwnDrive') then
  begin
   SQL := 'CREATE TABLE OwnDrive ([Pfad] TEXT,';
   SQL := SQL+'[Titel] VARCHAR (255),[Interpret] VARCHAR (255),[Dauer] VARCHAR (25),';
   SQL := SQL+'UNIQUE(Pfad));';
   smbdb.ExecSQL(SQL);
  end;
  AudioFile := TAudioFile.Create;
  anzeigeprogressbar[1].Max := DirList.Count-1;
  anzeigeprogressbar[1].Position := 0;
  for i:=0 to DirList.Count-1 do
  begin
   try
    AudioFile.GetAudioInfo(DirList[i]);
    AktDatei.Drive := ExtractFileDrive(DirList[i]);
    AktDatei.Gesamt:= DirList[i];
    Delete(AktDatei.Gesamt, 1, Length(AktDatei.Drive)+1);
    SQL := 'INSERT INTO OwnDrive(Pfad,Titel,Interpret,Dauer) VALUES';
    SQL := SQL+'("'+AktDatei.Gesamt+'","'+AudioFile.Titel+'","'+AudioFile.Interpret;
    SQL := SQL+'","'+IntToStr(AudioFile.Dauer)+'");';
    smbdb.ExecSQL(SQL);
   except
    bol := true;  //uU 2te Instanz von sSQL um Datenverlust zu verhindern?
    //Fehlermeldung ins Protokoll schreiben
   end;
   anzeigeprogressbar[1].Position := anzeigeprogressbar[1].Position+1;
  end;
 end else begin
  if not smbdb.TableExists(pcregname) then
  begin
   SQL := 'CREATE TABLE '+pcregname+' ([Pfad] TEXT,';
   SQL := SQL+'[Titel] VARCHAR (255),[Interpret] VARCHAR (255),[Dauer] VARCHAR (25),';
   SQL := SQL+'UNIQUE(Pfad));';
   smbdb.ExecSQL(SQL);
  end;

  AudioFile := TAudioFile.Create;
  anzeigeprogressbar[1].Max := DirList.Count-1;
  anzeigeprogressbar[1].Position := 0;
  for i:=0 to DirList.Count-1 do
  begin
   try
    AudioFile.GetAudioInfo(DirList[i]);
    SQL := 'INSERT INTO '+pcregname+'(Pfad,Titel,Interpret,Dauer) VALUES';
    SQL := SQL+'("'+AudioFile.Pfad+'","'+AudioFile.Titel+'","'+AudioFile.Interpret;
    SQL := SQL+'","'+IntToStr(AudioFile.Dauer)+'");';
    smbdb.ExecSQL(SQL);
   except
    bol := true;  //uU 2te Instanz von sSQL um Datenverlust zu verhindern?
    //Fehlermeldung ins Protokoll schreiben
   end;
   anzeigeprogressbar[1].Position := anzeigeprogressbar[1].Position+1;
  end;
 end;
 ShowMessage('Laden der Musik im gewählten Ordner beendet. Bitte die Anzeige der Bibliothek aktualisieren.');
end;

procedure TAddDir.Execute;
begin
 adddirbol := true;
 AddDirToBiblio();
 adddirbol := false;
end;

end.

